KG      equ  $1000
KGS     equ  $1001
DB      equ  $1002
DBS     equ  $1003
FARK    equ  $1004
MnYesil equ  12
KGyesil equ  $1005
DByesil equ  $1006
KGY     equ  $1007
DBY     equ  $1008
Saniye  equ  $0001
Sifir   equ  $0000
bas_adr equ  $0100
        org  bas_adr

        ldaa #20        Baslangicta KG=DB=20 saniye
        staa KGyesil
        staa DByesil
tst_et: ldaa KG
        cmpa DB
        bmi  DBbKG      DB > KG
        ldaa DB
        cmpa KG
        bmi  KGbDB      KG > DB
        bra  farkaz     KG=DB -> arac gecmiyor

KGbDB:  ldaa KG
        suba DB
        cmpa FARK
        bmi  farkaz     Yeterli fark yok
        ldaa DByesil
        cmpa #MnYesil
        bmi  uygula     DB 10 s.'nin altina dusemez
        inc  KGyesil    KG 2s artir
        inc  KGyesil
        dec  DByesil    DB 2s azalt
        dec  DByesil
        bra  uygula     degisen sureleri uygula

DBbKG:  ldaa DB
        suba KG
        cmpa FARK
        bmi  farkaz     Yeterli fark yok
        ldaa KGyesil
        cmpa #MnYesil
        bmi  uygula     KG 10 s.'nin altina dusemez
        inc  DByesil    DB 2s artir
        inc  DByesil
        dec  KGyesil    KG 2s azalt
        dec  KGyesil
        bra  uygula     degisen sureleri uygula

farkaz: ldaa KGyesil    sureler arasi farki azalt
        cmpa DByesil
        bmi  DBazal     DB > KG ?
        ldaa DByesil
        cmpa KGyesil
        bmi  KGazal     KG > DB ?
        bra  uygula
KGazal: dec  KGyesil    KG > DB -> KG azalir, DB artar
        inc  DByesil
        bra  uygula
DBazal: dec  DByesil    DB > KG -> DB azalir, KG artar
        inc  KGyesil

uygula: ldaa DBS        Sayaclari sifirla
        ldaa KGS
        clra            DB kirmizi
        staa DBY
        coma            KG yesil
        staa KGY        
        ldaa KGyesil    KG yesil suresi kadar bekle
        jsr  bekle
        clra            KG kirmizi
        staa KGY        
        coma            DB yesil
        staa DBY        
        ldaa DByesil    DB yesil suresi kadar bekle
        jsr  bekle
        jmp  tst_et     arac sayilarini test et

bekle:  ldx  #Saniye    1 saniye bekleme icin gereken sayac
tekrar: dex
        cpx  #Sifir
        bne  tekrar     1 saniye olmadi ise tekrarla
        deca
        bne  bekle
        rts
