dizi    equ  $1000
AD_adr  equ  $2000
Sayac   equ  $2001
Sayi_1  equ  $2002
Sayi_2  equ  $2003
Sonuc   equ  $2004
Toplam  equ  $2006
bas_adr equ  $0100

        org  bas_adr

        ldaa #256       Dizi eleman sayisi 20ms(50 Hz) / 100us(10 KHz)
        staa Sayac
        ldx  #dizi      indis <- dizinin baslangic adresi
AD_oku: ldaa AD_adr     Acc_A <- Read(A/D)
        staa ,x         V(indis) <- Acc_A
        inx             indis <- indis + 1
        dec  Sayac      Sayac <- Sayac - 1
        bne  AD_oku     Tum diziyi okuyana kadar tekrarla

        ldaa #256       Dizi eleman sayisi 20ms(50 Hz) / 100us(10 KHz)
        staa Sayac
        ldx  #dizi      indis <- dizinin baslangic adresi
KTopla: ldaa ,x         Sayi_1 = Sayi_2 = V(indis)
        staa Sayi_1     
        staa Sayi_2
        jsr  Carpma     Sonuc = V(indis) * V(indis)
        ldaa Sonuc+1    
        adda Toplam+1   Toplam_d = Toplam_d + Sonuc_d
        staa Toplam+1
        ldaa Sonuc
        adca Toplam     Toplam_y = Toplam_y + Sonuc_y (eldeye dikkat)
        staa Toplam
        inx
        dec  Sayac
        bne  KTopla
        
        ldaa #8         256'ya bolme = 8 bit saga kaydirma
        staa Sayac
Ortala: lsr  Toplam     
        ror  Toplam+1
        dec  Sayac
        bne  Ortala

        ldaa #63
        staa Kok
Kok_Al: staa Sayi_1     
        staa Sayi_2
        jsr  Carpma     Sonuc = V(indis) * V(indis)
        ldaa Sonuc+1
        suba Toplam+1
        staa Gecici+1
        ldaa Sonuc
        sbca Toplam
        staa Gecici
        
        asl  Kok        Payda <- 2 * Kok
        clra
        staa Bol_Son    Bolme sonucu <- 0
Bolme:  ldaa Gecici+1
        suba Kok
        staa Gecici+1
        ldaa Gecici
        sbca #0
        staa Gecici
        bmi  Bitti      Yuksek anlamli negatif -> bolme bitmistir
        inc  Bol_Son    Sonucu bir artir ve cikarmaya devam et
        bra  Bolme
Bitti:  ldaa Kok
        suba Bol_Son

